<template>
  <v-container fluid>
    <v-row dense>
      <v-col cols="12">
        <v-card :ripple="false" @click="disabled = false">
          <v-toolbar dense color="secondary">
            <v-icon>mdi-account</v-icon>
            <v-toolbar-title>Данные профиля</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  :key="`firstName-${profile.id}`"
                  v-model="firstName"
                  label="Имя"
                  type="text"
                  outlined
                  hide-details
                  :disabled="disabled"
                />
              </v-col>
              <v-col cols="12">
                <v-text-field
                  :key="`lastName-${profile.id}`"
                  v-model="lastName"
                  label="Фамилия"
                  type="text"
                  outlined
                  hide-details
                  :disabled="disabled"
                />
              </v-col>
              <v-col cols="12">
                <v-btn small color="primary" block @click="save" v-if="!disabled">Сохранить</v-btn>
              </v-col>
            </v-row>
          </v-card-text>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">

import Vue from "vue";
import Component from "vue-class-component";
import { Profile as ProfileEntity } from "@/domain/entity/profile/Profile";
import { Prop } from "vue-property-decorator";
import { ProfileEditRequest } from "@/domain/request/profile/ProfileEditRequest";

@Component({})
export default class Profile extends Vue {
  @Prop({
    required: true,
    type: Object
  })
  private readonly profile!: ProfileEntity;

  private firstName: string = this.profile.firstName;
  private lastName: string = this.profile.lastName;

  private disabled: boolean = true;

  public async save (event: Event): Promise<void> {
    await this.$store.dispatch('profile/edit', {
      id: this.profile.id,
      firstName: this.firstName,
      lastName: this.lastName
    } as ProfileEditRequest);
    this.disabled = true;
    event.stopPropagation();
  }
}

</script>

<style scoped>

</style>
